package org.springblade.community.feign;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.ApiParam;
import org.springblade.community.entity.Agency;
import org.springblade.community.vo.AgencyVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import javax.validation.Valid;
import java.util.List;

/**
 *  Feign
 *
 * @author lianghanqiang
 * @since 2021-03-29
 */
@FeignClient(value = "cyzh-community",path = "/feign/agency")
public interface IAgencyClient  {

	/**
	 * 详情
	 */
	@GetMapping("/detail")
    AgencyVO detail(@SpringQueryMap Agency agency);

	/**
	 * 通过id获取
	 */
	@GetMapping("/getById")
	Agency getById(@RequestParam Long id);

	/**
	 * 查询
	 */
	@GetMapping("/list")
    List<AgencyVO> list(@SpringQueryMap Agency agency);

	/**
	 * 查询
	 */
	@GetMapping("/listWithOutToken")
	List<AgencyVO> listWithOutToken(@SpringQueryMap Agency agency);



	/**
	 * 新增
	 */
	@PostMapping("/save")
	boolean save(@Valid @RequestBody Agency agency);

	/**
	 * 修改
	 */
	@PostMapping("/update")
    boolean update(@Valid @RequestBody Agency agency);

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
    boolean submit(@Valid @RequestBody Agency agency);


	/**
	 * 删除
	 */
	@PostMapping("/remove")
    boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids);

	/**
	 * 分页
	 */
	@PostMapping("/wrapperlist")
	List<Agency> wrapperlist(@RequestBody LambdaQueryWrapper<Agency> wrapper);

	@PostMapping("/listForOrg")
	List<Agency> listForOrg(@RequestBody Object[] params);
}
